// Use Plugin of Vite
const vitePluginScaff = require('@scaff/vite-plugin-node');

// Use Kit
const { deepmerge, extension, inf, clean } = require('./kit');

// Use Loaders
const { markdown } = require('./loaders');

// Import Mock Temp
// const mock = require('@scaff/vue-cli-mock');

// Init Scaff
module.exports = (api, options = {}, rootOptions = {}) => {
  // Get Configure from Vite
  const viteConfigure = vitePluginScaff().config();

  // Merge Options
  options = deepmerge(options, clean(viteConfigure));

  // Ser Mock Server
  // options.devServer.before = mock;

  // Configure Webpack
  api.configureWebpack(webpackConfigure => {
    // Change Entry as Inside
    webpackConfigure.entry.app = inf.main;
  });

  // Extension Webpack
  api.chainWebpack(webpackConfigure => {
    // Merge Configure from Vite
    webpackConfigure = deepmerge(webpackConfigure, viteConfigure);

    // Extension for CLI
    webpackConfigure = extension(webpackConfigure, options);

    /**
     * Extension Markdown
     * ========== ========== ==========
     */
    markdown(webpackConfigure);
  });
};
